Index: rsion-He3/RMDaemon
===================================================================
--- version-He3/RMDaemon	(revision cb8510a3aec6557879e6f268e9d35ad8c99310ef)
+++ 	(revision )
@@ -1,1 +1,0 @@
-nohup ./RMmantid.py>log & 
Index: rsion-He3/getCommand-20180225.py
===================================================================
--- version-He3/getCommand-20180225.py	(revision cb8510a3aec6557879e6f268e9d35ad8c99310ef)
+++ 	(revision )
@@ -1,121 +1,0 @@
-import jsonArray
-import time
-from multiprocessing import Process, Manager
-import threading
-import json
-import logging
-
-def stateMachine(command, status, commandList, statusList,myDict):
-    
-    if command == 0:
-        if status == 1:
-            myDict["configure"]= True
-            status = 3
-        else:
-            print statusList[status]+" status cannot receive "+commandList[command]+" command"
-    
-    elif command == 1:
-        if status == 3:
-            myDict["configure"]=False
-            status = 1
-        else:
-            print statusList[status]+" status cannot receive "+commandList[command]+" command"
-
-    elif command == 2:
-        if status == 3:
-            myDict["running"]=True
-            status = 4
-        else:
-            print statusList[status]+" status cannot receive "+commandList[command]+" command"
-
-    elif command == 3:
-        if status == 4:
-            myDict['running']=False
-            status = 5
-        else:
-            print statusList[status]+" status cannot receive "+commandList[command]+" command"
-
-    elif command == 4:
-        if status == 5:
-            myDict['running']=True
-            status = 4
-        else:
-            print statusList[status]+" status cannot receive "+commandList[command]+" command"
-
-    elif command == 5:
-        if status == 4:
-            myDict['running']= False
-            status = 3
-        else:
-            print statusList[status]+" status cannot receive "+commandList[command]+" command"
-    
-    elif command == 6:
-        myDict['running']=False
-        myDict['configure']=False
-        myDict['error']=False
-        status = 1
-    else:
-        pass
-
-    return status
-
-class getCommand(threading.Thread):
-    def __init__(self, neonRedis_write, neonRedis_read, refreshtime,myDict, logger):
-        super(getCommand, self).__init__()
-        self.neonRedis_write = neonRedis_write
-        self.neonRedis_read = neonRedis_read
-        self.refreshtime = refreshtime
-        self.myDict=myDict
-        self.logger=logger
-        self.command=-1
-        self.commandList=['configure','unconfigure','start','pause','resume','stop','abort']
-        self.statusList=['waiting','unconfigured','configuring','ready','running','paused','error']
-
-    def getCommand(self):
-        #_path="/MR/control/test"
-        _path="/MR/control/command/mantid"
-        try:
-            _json=self.neonRedis_read.get(_path)
-            _data=int(json.loads(_json))
-        except:
-            _data=-1
-        return _data
-
-    def setCommand(self, command):
-        self.command=command
-
-    def setStatus(self, status):
-        path="/MR/stateMachine/status"
-        self.neonRedis_write.set(path, json.dumps(status))
-    
-    def getStatus(self):
-        path="/MR/stateMachine/status"
-        _json=self.neonRedis_read.get(path)
-        data=int(json.loads(_json))
-        return data
-
-    def process(self):
-        while True:
-            if self.myDict['error']:
-                status = 6
-                self.setStatus(status)
-
-            _command=self.getCommand()
-            while type(_command)!=int:
-                print "the type of command is not int!!!"
-                time.sleep(5)
-                _command=self.getCommand()
-            if self.command==_command:
-                pass
-            else:
-                self.setCommand(_command)
-                print "new command: ", self.command
-                status=self.getStatus()
-                print "before statemachine: ", status
-                tmp=stateMachine(self.command, status, self.commandList, self.statusList, self.myDict)
-                self.setStatus(tmp)
-                print "after statemachine: ",tmp
-            time.sleep(self.refreshtime)
-
-    def run(self):
-        self.process()
Index: rsion-He3/instrument/monitor.xml
===================================================================
--- version-He3/instrument/monitor.xml	(revision cb8510a3aec6557879e6f268e9d35ad8c99310ef)
+++ 	(revision )
@@ -1,45 +1,0 @@
-<instrument name="MR" valid-from   ="2012-04-29 00:00:00"
-                       valid-to     ="2050-01-01 00:00:00"
-               last-modified="2017-03-06 00:00:00">
-  <!--Created by DU-->
-  <!--DEFAULTS-->
-  <defaults>
-    <length unit="metre"/>
-    <angle unit="degree"/>
-    <reference-frame>
-    <!-- The z-axis is set parallel to and in the direction of the beam. the 
-           y-axis points up and the coordinate system is right handed. -->
-      <along-beam axis="z"/>
-      <pointing-up axis="y"/>
-      <handedness val="right"/>
-    </reference-frame>
-  </defaults>
-  <!--SOURCE-->
-  <component type="moderator">
-    <location z="-19.504"/>
-  </component>
-  <type is="Source" name="moderator"/>
-  <!--SAMPLE-->
-  <component type="sample-position">
-    <location x="0.0" y="0.0" z="0.0"/>
-  </component>
-  <type is="SamplePos" name="sample-position"/>
-  <!-- MONITOR-->
-  <component type="monitor1" idlist="monitor1-list">
-    <location x="0.0" y="0.0" z="-18.869" mark-as="monitor"/>
-  </component>
-
-  <!-- Pixel for Detectors (100x124)-->
-  <type is="monitor" name="monitor1">
-    <cuboid id="pixel-shape">
-      <left-front-bottom-point x="-0.002" y="-0.002" z="0.0"  />
-      <left-front-top-point  x="-0.002" y="0.002" z="0.0"  />
-      <left-back-bottom-point  x="-0.002" y="-0.002" z="-0.0001"  />
-      <right-front-bottom-point  x="0.002" y="-0.002" z="0.0"  />
-    </cuboid>
-    <algebra val="pixel-shape"/>
-  </type>
-  <idlist idname="monitor1-list">
-    <id val="1" />
-  </idlist>
-</instrument>
Index: version-He3/neonIO.py
===================================================================
--- version-He3/neonIO.py	(revision 6ad61706b2eaf3f1f5e5c6fcfbc60bd31cf04863)
+++ version-He3/neonIO.py	(revision 276cefb62943d08a49b249761f317ff94da6d53f)
@@ -26,5 +26,7 @@
         #self.detValue=[]
         #self.monValue=[]
-        
+	self.waveRebin = "2.4,0.005,6.9"
+        self.qRebin="0.0005,0.001,0.4"
+
         self.tof=[]
         self.detPid=[]
@@ -37,5 +39,5 @@
     def getConf(self):
         be=time.time()
-        path="/MR/control/configure1"
+        path="/MR/control/configure"
         _json=self.neonRedis_read.get(path)
         _conf=json.loads(_json)
@@ -111,8 +113,6 @@
     def createWorkspace(self):
         be=time.time()
-        #print len(self.detPid), len(self.tof), len(self.detValue), len(self.monPid), len(self.monValue)
         if self.detJudge:
             LoadCSNSRaw(OutputWorkspace="sample", PixelID_bank=self.detPid, TimeOfFlight_bank=self.tof, Counts_bank=self.detValue, PixelID_monitor=[0,1], TimeOfFlight_monitor=[8,16], Counts_monitor=[1,1])
-            #LoadInstrument(Workspace="sample_1", Filename='./instrument/detector.xml', RewriteSpectraMap='True')
             LoadInstrument(Workspace="sample_1", Filename='./instrument/detector_ver.xml', RewriteSpectraMap='True')
             #RotateInstrumentComponent(Workspace="sample_1", ComponentName="Bank01", X=0, Y=0, Z=1, Angle=90, RelativeRotation=False)
@@ -126,4 +126,6 @@
                 try:
                     _cmd = 'scp sample.nxs root@10.1.26.157:/userData/BL02/'
+                    subprocess.check_call(_cmd, shell=True)
+                    _cmd = 'scp sample.nxs zhanxz@10.1.252.40:/home/zhanxz/'
                     subprocess.check_call(_cmd, shell=True)
                     print 'finish set online data'
@@ -156,12 +158,14 @@
             SumSpectra(InputWorkspace='__tmp', OutputWorkspace="waveCounts", IncludeMonitors=False)
             ConvertUnits(InputWorkspace='waveCounts',OutputWorkspace='tofCounts',Target='TOF',AlignBins=True)
-            
+	    LoadNexus(Filename="DB.nxs",OutputWorkspace="DB")
+            Rebin(InputWorkspace="DB",OutputWorkspace="DB", Params=self.waveRebin) 
             #LoadInstrument(Workspace="tofCounts", Filename='./instrument/onePid.xml', RewriteSpectraMap='True')
             #ConvertUnits(InputWorkspace="tofCounts",OutputWorkspace='waveCounts',Target='Wavelength',AlignBins=True)
             proton=self.getProtonCharge()
-            CreateSingleValuedWorkspace(OutputWorkspace="__pro", DataValue=proton)
-            Divide(LHSWorkspace="waveCounts", RHSWorkspace="__pro", OutputWorkspace="nor_wave")
+	    mtd['nor_wave']=mtd["waveCounts"]*1.0/proton
+            Rebin(InputWorkspace="nor_wave",OutputWorkspace="nor_wave", Params=self.waveRebin) 
+            Divide(LHSWorkspace="nor_wave", RHSWorkspace="DB", OutputWorkspace="nor_wave")
             ConvertUnits(InputWorkspace='nor_wave',OutputWorkspace='qCounts_P',Target='MomentumTransfer',AlignBins=True)
-            Rebin(InputWorkspace="qCounts_P",OutputWorkspace="qCounts_P", Params='0.0005,0.001,0.4')
+            Rebin(InputWorkspace="qCounts_P",OutputWorkspace="qCounts_P", Params=self.qRebin)
             #Rebin(InputWorkspace="tofCounts",OutputWorkspace="tofCounts", Params='0,16,40000')
         else:
@@ -293,5 +297,5 @@
             v[j].append((_pos.Y())*100)
             v[j].append(sum(name.readY(j)))
-	print v
+	#print v
 	#time.sleep(60)
         xaxis=list(set(xaxis))
@@ -529,5 +533,6 @@
                         #    self.logger.warning("no monitor nexus file!!!")
 
-                        #DeleteWorkspace(Workspace='sample')
+                        DeleteWorkspace(Workspace='sample')
+			CleanFileCache()
                         self.logger.debug("time is "+str(time.time()-be)+" seconds!!!")
                     '''
@@ -548,8 +553,8 @@
             self.detJudge=True
             self.monJudge=True
-            try:
-                self.process()
-            except:
-                self.logger.error("error happens!!!")
-            time.sleep(0.5)
-
+            #try:
+            self.process()
+            #except:
+            #    self.logger.error("error happens!!!")
+            time.sleep(2)
+
Index: version-He3/test/hb_com.py
===================================================================
--- version-He3/test/hb_com.py	(revision 6ad61706b2eaf3f1f5e5c6fcfbc60bd31cf04863)
+++ version-He3/test/hb_com.py	(revision 276cefb62943d08a49b249761f317ff94da6d53f)
@@ -4,5 +4,5 @@
 import connect
 import jsonArray
-
+import sys
 if __name__ == '__main__':
     # ======Try to connect NEON server
@@ -22,8 +22,10 @@
     path3='/MR/heartbeat/pilot' 
     path="/MR/workspace/MantidData/roi"
+    path = "/MR/control/configure"
     x=r_read.get(path)
     y=r_read.get(path2)
     z=r_read.get(path3)
-   
+    print x
+    sys.exit()
     print x, y
     print x, z
Index: rsion-MWPC/RMDaemon
===================================================================
--- version-MWPC/RMDaemon	(revision cb8510a3aec6557879e6f268e9d35ad8c99310ef)
+++ 	(revision )
@@ -1,1 +1,0 @@
-nohup ./RMmantid.py & 
Index: rsion-MWPC/getCommand-20180225.py
===================================================================
--- version-MWPC/getCommand-20180225.py	(revision cb8510a3aec6557879e6f268e9d35ad8c99310ef)
+++ 	(revision )
@@ -1,121 +1,0 @@
-import jsonArray
-import time
-from multiprocessing import Process, Manager
-import threading
-import json
-import logging
-
-def stateMachine(command, status, commandList, statusList,myDict):
-    
-    if command == 0:
-        if status == 1:
-            myDict["configure"]= True
-            status = 3
-        else:
-            print statusList[status]+" status cannot receive "+commandList[command]+" command"
-    
-    elif command == 1:
-        if status == 3:
-            myDict["configure"]=False
-            status = 1
-        else:
-            print statusList[status]+" status cannot receive "+commandList[command]+" command"
-
-    elif command == 2:
-        if status == 3:
-            myDict["running"]=True
-            status = 4
-        else:
-            print statusList[status]+" status cannot receive "+commandList[command]+" command"
-
-    elif command == 3:
-        if status == 4:
-            myDict['running']=False
-            status = 5
-        else:
-            print statusList[status]+" status cannot receive "+commandList[command]+" command"
-
-    elif command == 4:
-        if status == 5:
-            myDict['running']=True
-            status = 4
-        else:
-            print statusList[status]+" status cannot receive "+commandList[command]+" command"
-
-    elif command == 5:
-        if status == 4:
-            myDict['running']= False
-            status = 3
-        else:
-            print statusList[status]+" status cannot receive "+commandList[command]+" command"
-    
-    elif command == 6:
-        myDict['running']=False
-        myDict['configure']=False
-        myDict['error']=False
-        status = 1
-    else:
-        pass
-
-    return status
-
-class getCommand(threading.Thread):
-    def __init__(self, neonRedis_write, neonRedis_read, refreshtime,myDict, logger):
-        super(getCommand, self).__init__()
-        self.neonRedis_write = neonRedis_write
-        self.neonRedis_read = neonRedis_read
-        self.refreshtime = refreshtime
-        self.myDict=myDict
-        self.logger=logger
-        self.command=-1
-        self.commandList=['configure','unconfigure','start','pause','resume','stop','abort']
-        self.statusList=['waiting','unconfigured','configuring','ready','running','paused','error']
-
-    def getCommand(self):
-        #_path="/MR/control/test"
-        _path="/MR/control/command/mantid"
-        try:
-            _json=self.neonRedis_read.get(_path)
-            _data=int(json.loads(_json))
-        except:
-            _data=-1
-        return _data
-
-    def setCommand(self, command):
-        self.command=command
-
-    def setStatus(self, status):
-        path="/MR/stateMachine/status"
-        self.neonRedis_write.set(path, json.dumps(status))
-    
-    def getStatus(self):
-        path="/MR/stateMachine/status"
-        _json=self.neonRedis_read.get(path)
-        data=int(json.loads(_json))
-        return data
-
-    def process(self):
-        while True:
-            if self.myDict['error']:
-                status = 6
-                self.setStatus(status)
-
-            _command=self.getCommand()
-            while type(_command)!=int:
-                print "the type of command is not int!!!"
-                time.sleep(5)
-                _command=self.getCommand()
-            if self.command==_command:
-                pass
-            else:
-                self.setCommand(_command)
-                print "new command: ", self.command
-                status=self.getStatus()
-                print "before statemachine: ", status
-                tmp=stateMachine(self.command, status, self.commandList, self.statusList, self.myDict)
-                self.setStatus(tmp)
-                print "after statemachine: ",tmp
-            time.sleep(self.refreshtime)
-
-    def run(self):
-        self.process()
Index: version-MWPC/neonIO.py
===================================================================
--- version-MWPC/neonIO.py	(revision 72971aeec286236fbf8e40f546ae64a4cb838446)
+++ version-MWPC/neonIO.py	(revision 276cefb62943d08a49b249761f317ff94da6d53f)
@@ -117,5 +117,7 @@
                     _cmd = 'scp sample.nxs root@10.1.26.157:/userData/BL02/'
                     subprocess.check_call(_cmd, shell=True)
-                    self.logger.debug('send online data to cloud!') 
+                    _cmd = 'scp sample.nxs zhanxz@10.1.252.40:/home/zhanxz/'
+                    subprocess.check_call(_cmd, shell=True)
+		    self.logger.debug('send online data to cloud!') 
                 except:
                     self.logger.debug('error in scp!')
Index: rsion-MWPC/res.dat
===================================================================
--- version-MWPC/res.dat	(revision 72971aeec286236fbf8e40f546ae64a4cb838446)
+++ 	(revision )
@@ -1,421 +1,0 @@
-0;2.976g
-0;2.837g
-0;2.933g
-0;3.097g
-0;2.839g
-0;3.079g
-0;2.976g
-0;2.858g
-0;2.981g
-0;2.839g
-0;3.048g
-0;2.979g
-0;2.980g
-0;2.840g
-0;2.842g
-0;2.984g
-0;2.841g
-0;2.933g
-0;2.840g
-0;2.841g
-0;3.042g
-0;2.981g
-0;2.936g
-0;2.841g
-0;2.980g
-0;2.842g
-0;2.925g
-0;2.981g
-0;2.968g
-0;2.842g
-0;2.964g
-0;2.841g
-0;2.841g
-0;2.982g
-0;2.842g
-0;3.084g
-0;2.982g
-0;2.973g
-0;2.842g
-0;2.982g
-0;2.843g
-0;2.983g
-0;2.844g
-0;3.029g
-0;2.983g
-0;3.029g
-0;2.844g
-0;2.984g
-0;2.844g
-0;3.030g
-0;2.984g
-0;2.936g
-0;2.844g
-0;2.984g
-0;2.844g
-0;2.920g
-0;2.983g
-0;2.845g
-0;2.939g
-0;2.984g
-0;2.963g
-0;2.845g
-0;2.985g
-0;2.845g
-0;3.077g
-0;2.984g
-0;2.938g
-0;2.844g
-0;2.983g
-0;2.843g
-0;3.024g
-0;2.984g
-0;2.938g
-0;2.844g
-0;2.985g
-0;2.844g
-0;2.945g
-0;2.984g
-0;2.845g
-0;2.938g
-0;2.844g
-0;2.979g
-0;2.845g
-0;2.843g
-0;2.985g
-0;2.844g
-0;3.065g
-0;2.985g
-0;2.938g
-0;2.845g
-0;2.985g
-0;2.845g
-0;2.936g
-0;2.983g
-0;2.938g
-0;2.845g
-0;2.985g
-0;2.845g
-0;2.915g
-0;2.985g
-0;2.846g
-0;2.974g
-0;2.845g
-0;2.986g
-0;2.846g
-0;2.848g
-0;2.988g
-0;2.847g
-0;2.938g
-0;2.894g
-0;2.970g
-0;2.846g
-0;2.846g
-0;2.986g
-0;2.845g
-0;3.042g
-0;2.986g
-0;2.939g
-0;2.847g
-0;2.986g
-0;2.846g
-0;2.846g
-0;2.988g
-0;2.848g
-0;2.939g
-0;2.987g
-0;2.980g
-0;2.848g
-0;2.986g
-0;2.846g
-0;3.000g
-0;2.987g
-0;2.939g
-0;2.845g
-0;2.988g
-0;2.847g
-0;2.856g
-0;3.022g
-0;2.846g
-0;2.941g
-0;2.848g
-0;2.986g
-0;2.847g
-0;2.846g
-0;2.988g
-0;2.848g
-0;2.913g
-0;2.990g
-0;2.846g
-0;2.942g
-0;2.849g
-0;2.972g
-0;2.845g
-0;2.848g
-0;2.987g
-0;2.848g
-0;3.095g
-0;2.985g
-0;2.984g
-0;2.849g
-0;2.986g
-0;2.848g
-0;3.006g
-0;2.988g
-0;2.941g
-0;2.849g
-0;2.989g
-0;2.850g
-0;2.894g
-0;2.988g
-0;2.849g
-0;2.942g
-0;2.848g
-0;2.972g
-0;2.847g
-0;2.849g
-0;2.989g
-0;2.850g
-0;3.036g
-0;2.987g
-0;3.034g
-0;2.851g
-0;2.849g
-0;2.988g
-0;2.848g
-0;2.927g
-0;2.990g
-0;2.941g
-0;2.847g
-0;2.989g
-0;2.851g
-0;3.004g
-0;2.989g
-0;2.942g
-0;2.849g
-0;2.989g
-0;2.848g
-0;2.857g
-0;2.991g
-0;2.850g
-0;3.097g
-0;2.990g
-0;2.961g
-0;2.850g
-0;2.849g
-0;2.990g
-0;2.849g
-0;2.942g
-0;2.988g
-0;2.943g
-0;2.850g
-0;2.989g
-0;2.850g
-0;2.850g
-0;2.990g
-0;2.851g
-0;2.856g
-0;2.989g
-0;2.954g
-0;2.848g
-0;2.848g
-0;2.990g
-0;2.848g
-0;3.019g
-0;2.989g
-0;2.980g
-0;2.852g
-0;2.980g
-0;2.849g
-0;2.849g
-0;2.988g
-0;2.850g
-0;3.047g
-0;2.989g
-0;2.943g
-0;2.849g
-0;2.989g
-0;2.850g
-0;2.927g
-0;2.989g
-0;2.849g
-0;2.943g
-0;2.848g
-0;2.948g
-0;2.850g
-0;2.989g
-0;2.850g
-0;3.065g
-0;2.991g
-0;2.982g
-0;2.850g
-0;2.989g
-0;2.850g
-0;2.993g
-0;2.988g
-0;2.941g
-0;2.849g
-0;2.990g
-0;2.849g
-0;2.848g
-0;2.991g
-0;2.850g
-0;3.029g
-0;2.850g
-0;2.949g
-0;2.850g
-0;2.991g
-0;2.850g
-0;3.033g
-0;2.990g
-0;2.986g
-0;2.849g
-0;2.988g
-0;2.851g
-0;2.973g
-0;2.989g
-0;2.943g
-0;2.851g
-0;2.979g
-0;2.850g
-0;2.849g
-0;2.988g
-0;2.849g
-0;3.062g
-0;2.989g
-0;2.986g
-0;2.850g
-0;2.991g
-0;2.849g
-0;2.933g
-0;2.990g
-0;2.850g
-0;2.945g
-0;2.850g
-0;3.009g
-0;2.850g
-0;2.851g
-0;2.990g
-0;2.850g
-0;2.942g
-0;2.990g
-0;2.946g
-0;2.851g
-0;2.990g
-0;2.850g
-0;2.956g
-0;2.989g
-0;2.982g
-0;2.850g
-0;2.991g
-0;2.851g
-0;2.899g
-0;2.992g
-0;2.850g
-0;2.944g
-0;2.851g
-0;2.990g
-0;2.852g
-0;2.851g
-0;3.030g
-0;2.851g
-0;2.943g
-0;2.991g
-0;3.039g
-0;2.849g
-0;2.990g
-0;2.851g
-0;3.002g
-0;2.989g
-0;2.944g
-0;2.850g
-0;2.988g
-0;2.850g
-0;2.852g
-0;2.993g
-0;2.851g
-0;2.944g
-0;2.852g
-0;2.989g
-0;2.851g
-0;2.850g
-0;2.991g
-0;2.851g
-0;3.054g
-0;2.991g
-0;2.945g
-0;2.854g
-0;2.992g
-0;2.853g
-0;3.030g
-0;2.991g
-0;2.990g
-0;2.850g
-0;2.991g
-0;2.851g
-0;3.013g
-0;2.991g
-0;2.946g
-0;2.850g
-0;2.990g
-0;2.851g
-0;2.971g
-0;2.992g
-0;2.945g
-0;2.852g
-0;2.991g
-0;2.851g
-0;2.944g
-0;2.991g
-0;2.852g
-0;2.944g
-0;2.852g
-0;2.991g
-0;2.851g
-0;2.862g
-0;2.990g
-0;2.852g
-0;2.945g
-0;2.852g
-0;2.992g
-0;2.852g
-0;2.863g
-0;2.991g
-0;2.853g
-0;2.945g
-0;2.991g
-0;2.978g
-0;2.850g
-0;2.851g
-0;2.991g
-0;2.853g
-0;3.069g
-0;2.991g
-0;2.990g
-0;2.852g
-0;2.991g
-0;2.853g
-0;3.053g
-0;2.994g
-0;2.946g
-0;2.852g
-0;2.992g
-0;2.852g
-0;2.973g
-0;2.991g
-0;2.945g
-0;2.852g
-0;2.992g
-0;2.853g
-0;2.942g
-0;2.991g
-0;2.985g
-0;2.852g
-0;2.993g
-0;2.852g
-0;2.875g
-0;2.992g
-0;2.852g
-0;2.945g
-0;2.852g
-0;2.992g
Index: rsion-MWPC/testRES.py
===================================================================
--- version-MWPC/testRES.py	(revision 4b69a653ed6fc929b38a7e32006898a747528069)
+++ 	(revision )
@@ -1,24 +1,0 @@
-import os
-import subprocess
-import time
-import sys
-t=0
-while True:
-    _cmd="top -n 1 | grep 139146"
-    try:
-        a = subprocess.check_output(_cmd, shell=True)
-        a=a.split(' ')
-        for i in range(len(a)-1,-1,-1):
-            if a[i]=='':
-                a.remove('')
-        print t,';',a
-        res=a[5]
-        print t,';',res,'\n'
-        f=open('res.dat','a+')
-        f.write(str(t)+';'+str(res)+'\n')
-        f.close()
-    except:
-        pass
-    #t=t+1
-    #sys.exit()
-    time.sleep(60)